Consensus <- function(amat, maxm, t0, iter) {

    tinf = 0.00001
    c = exp(log(tinf)/(t0)/iter)

    amatdim = dim(amat)
    n = amatdim[1]
    alpha = (max(amat)-min(amat))/2
#    print(amat)
    print(alpha)
    result = trunc(runif(n)*(maxm))+1

#   R OPTIMISATION
#   result = optim(result, ConsensusFn, method="SANN",control=list(fnscale=-1, maxit=1000000, temp=5,trace=1)) 

#   HILL CLIMB / SA
    fitness = ConsensusFn(result, amat, alpha)
    t=t0
    for (i in 1:iter)
    {
        position = trunc(runif(1,1,n))
        oldval = result[position]
        oldfitness = fitness
        newval = trunc(runif(1,1,(maxm)))+1
        while (newval==oldval)
        {
            newval = trunc(runif(1,1,(maxm)))+1
        } 
        result[position]=newval
        fitness = oldfitness+ConsensusFnChange(oldval,newval,position,result,amat,alpha) 
        #fitness = ConsensusFn(result, amat, alpha)
        if(fitness<oldfitness)
        {
            df = fitness-oldfitness
            if (runif(1) > exp(df/t))            {
                result[position]=oldval
                fitness=oldfitness
            }
        }
        else
        {
#            print(c(oldval, '->', newval, ' at ', position, ': ', fitness))
        }
        t=t*c
#       print(iter-i)
    }
    print(fitness)
    print(ConsensusFn(result, amat, alpha))
    Consensus = result
}
